//---------------------------------------------------------------------------
//
// Name:        TextGameFrm.h
// Author:      Kirill
// Created:     18.08.2009 11:42:01
// Description: TextGameFrm class declaration
//
//---------------------------------------------------------------------------

#ifndef __TEXTGAMEFRM_h__
#define __TEXTGAMEFRM_h__

#ifdef __BORLANDC__
	#pragma hdrstop
#endif

#ifndef WX_PRECOMP
	#include <wx/wx.h>
	#include <wx/frame.h>
#else
	#include <wx/wxprec.h>
#endif

//Do not add custom headers between 
//Header Include Start and Header Include End.
//wxDev-C++ designer will remove them. Add custom headers after the block.
////Header Include Start
#include <wx/richtext/richtextctrl.h>
#include <wx/statusbr.h>
#include <wx/button.h>
#include <wx/toolbar.h>
////Header Include End

////Dialog Style Start
#undef TextGameFrm_STYLE
#define TextGameFrm_STYLE wxCAPTION | wxSYSTEM_MENU | wxMINIMIZE_BOX | wxCLOSE_BOX
////Dialog Style End

class TextGameFrm : public wxFrame
{
	private:
		DECLARE_EVENT_TABLE();
		
	public:
		TextGameFrm(wxWindow *parent, wxWindowID id = 1, const wxString &title = wxT("TextGame"), const wxPoint& pos = wxDefaultPosition, const wxSize& size = wxDefaultSize, long style = TextGameFrm_STYLE);
		virtual ~TextGameFrm();
		void OnKeyDown(wxKeyEvent& event);
		void ConnectKeyDownEvent(wxWindow* pclComponent);
		void SetRoom(int current_room);
		void SetCharacter(int current_room);
		void SetEvent(int current_room);
		void FindCollectable(int current_room);
		bool BagIsEmpty();
		void EmptyBag();
		void Death();
		void UseItems();
		void DropItems();
		void InitRooms();
		void InitCharacters();
		void LeftButtonClick(wxCommandEvent& event);
		void RightButtonClick(wxCommandEvent& event);
		void NothingButtonClick(wxCommandEvent& event);
		void TakeButtonClick(wxCommandEvent& event);
		void DropButtonClick(wxCommandEvent& event);
		
	private:
		//Do not add custom control declarations between
		//GUI Control Declaration Start and GUI Control Declaration End.
		//wxDev-C++ will remove them. Add custom code after the block.
		////GUI Control Declaration Start
		wxRichTextCtrl *Screen;
		wxStatusBar *WxStatusBar1;
		wxButton *RightButton;
		wxButton *DropButton;
		wxButton *TakeButton;
		wxButton *UseButton;
		wxButton *LeftButton;
		wxToolBar *WxToolBar1;
		////GUI Control Declaration End
		
	private:
		//Note: if you receive any error with these enum IDs, then you need to
		//change your old form code that are based on the #define control IDs.
		//#defines may replace a numeric value for the enum names.
		//Try copy and pasting the below block in your old form header files.
		enum
		{
			////GUI Enum Control ID Start
			ID_SCREEN = 1004,
			ID_WXSTATUSBAR1 = 1003,
			ID_RIGHTBUTTON = 1006,
			ID_DROPBUTTON = 1009,
			ID_TAKEBUTTON = 1008,
			ID_USEBUTTON = 1007,
			ID_LEFTBUTTON = 1005,
			ID_WXTOOLBAR1 = 1001,
			////GUI Enum Control ID End
			ID_DUMMY_VALUE_ //don't remove this value unless you have other enum values
		};
		
	private:
		void OnClose(wxCloseEvent& event);
		void CreateGUIControls();
};

#endif
